package com.jaspereport.sample;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;
import net.sf.jasperreports.engine.design.JasperDesign;
import net.sf.jasperreports.engine.xml.JRXmlLoader;

/*
 * Скачать библиотеки JasperReport
 * http://www.java2s.com/Code/Jar/j/Downloadjaspercompilerjdt559jar.htm
 */

public class Generator
{
//	private  final  String PROJECT_PATH   = "D:\\projects\\gwt_examples\\report-group";
	private  final  String PROJECT_PATH   = "F:\\Projects\\eclipse.maven\\report-group";
	private  final  String REPORT_pdf     = "\\report.pdf";
//	private  final  String REPORT_pattern = "\\jrxml\\first_report.jrxml";
	private  final  String REPORT_pattern = "\\jrxml\\group_report.jrxml";

	public void create() throws JRException
	{
		DAOStub dataBeanMaker = new DAOStub();
		ArrayList<DataBean> dataBeanList = dataBeanMaker.getDataBeanList();

		
		JRBeanCollectionDataSource beanColDataSource = new JRBeanCollectionDataSource(dataBeanList);
		Map<String, Object> parameters = new HashMap<String, Object>();
		parameters.put("DATE", new Date());

		File reportPattern = new File(PROJECT_PATH + REPORT_pattern);
		JasperDesign jasperDesign = JRXmlLoader.load(reportPattern);
		JasperReport jasperReport = JasperCompileManager.compileReport(jasperDesign);
//		JasperReport jasperReport = JasperCompileManager.compileReport(this.getClass().getClassLoader() .getResourceAsStream(pathForPattern));
		JasperPrint jasperPrint = JasperFillManager.fillReport(jasperReport, parameters, beanColDataSource);
		JasperExportManager.exportReportToPdfFile(jasperPrint, PROJECT_PATH + REPORT_pdf);
	}

	public static void main(String[] args) {
		System.out.println("Начало генерации отчёта");
		try {
			new Generator().create();
			System.out.println("Генерация отчёта завершена");
		} catch (Exception e) {
			System.err.println("Во время генерации возникла ошибка: " + e);
		}
	}
}
